using System.Linq;
using System.Windows;
using System.Windows.Input;
using Elwig.Documents;
using Elwig.Helpers;
using Microsoft.EntityFrameworkCore;

namespace Elwig.Windows {
    public partial class MainWindow : Window {

        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs evt) {
            PdfButton.IsEnabled = App.IsPrintingReady;
        }

        private void MemberAdminButton_Click(object sender, RoutedEventArgs evt) {
            var w = new MemberAdminWindow();
            w.Show();
        }

        private void MemberListButton_Click(object sender, RoutedEventArgs evt) {
            var w = new MemberListWindow();
            w.Show();
        }

        private void ReceiptButton_Click(object sender, RoutedEventArgs evt) {
            var w = new DeliveryAdminWindow(true);
            w.Show();
        }

        private void DeliveryAdminButton_Click(object sender, RoutedEventArgs evt) {
            var w = new DeliveryAdminWindow();
            w.Show();
        }

        private void DeliveryListButton_Click(object sender, RoutedEventArgs evt) {
            // TODO
        }

        private async void PdfButton_Click(object sender, RoutedEventArgs evt) {
            Mouse.OverrideCursor = Cursors.Wait;
            using var ctx = new AppDbContext();
            using var doc = new DeliveryNote(await ctx.Deliveries.OrderBy(d => d.Parts.Count).ThenBy(d => d.Year).ThenBy(d => d.DId).LastAsync(), ctx);
            await doc.Generate();
            doc.Show();
            Mouse.OverrideCursor = null;
        }

        private void TestWindowButton_Click(object sender, RoutedEventArgs evt) {
            var w = new TestWindow();
            w.Show();
        }

        private void QueryWindowButton_Click(object sender, RoutedEventArgs evt) {
            var w = new QueryWindow();
            w.Show();
        }

        private void BaseDataButton_Click(object sender, RoutedEventArgs evt) {
            var w = new BaseDataWindow();
            w.Show();
        }

        private void PaymentWindowButton_Click(object sender, RoutedEventArgs e) {
            var w = new ChartWindow();
            w.Show();
        }
    }
}
